CREATE OR REPLACE VIEW V_KUPCI_SALDAKONTI AS (
SELECT CONCAT(CONCAT(K.ID, CASE WHEN N.ID IS NULL THEN '' ELSE '-' END), N.ID) AS V_KUPCI_SALDAKONTI_ID, K.ID AS KUPCI_ID, N.ID AS NNFIRMA_ID, K.VALUTA_PLACILA,
  (CASE WHEN K.VALUTA_PLACILA IS NULL OR K.VALUTA_PLACILA = (SELECT DOMACAVALUTA FROM PARAM) THEN 'Y' ELSE 'N' END) AS KUPCI_DOMACA_VALUTA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK,
  -- Parcialne ponudbe, domaca valuta
  (
    SELECT SUM(M.OPEN_AMOUNT)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y'
  ) AS SALDAKONTI_PART_PROFORMA_SIT,
  
   -- Parcialne ponudbe, tuja valuta (skupajVal*openAmount/skupaj)
  (
    (SELECT COALESCE(SUM(M.SKUPAJ_VAL), 0)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y') 
    * (SELECT COALESCE(SUM(M.OPEN_AMOUNT), 0)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y')
    / (SELECT CASE WHEN (COALESCE(SUM(M.SKUPAJ), 0) = 0) THEN 1 ELSE SUM(M.SKUPAJ) END
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P' AND M.CONFIRMED = 'Y')
  ) AS SALDAKONTI_PART_PROFORMA_DEM,
  
  -- Ponudbe, domaca valuta
  (
    SELECT SUM(M.SKUPAJ)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P'
  ) AS SALDAKONTI_PROFORMA_SIT,
  
  -- Ponudbe, tuja valuta
  (
    SELECT SUM(M.SKUPAJ_VAL)
    FROM M_DE_NA M WHERE M.ID_LASTNIKA = K.ID AND (N.ID IS NULL OR M.NNLOCATION_ID IN (SELECT NL.ID FROM NNLOCATION NL WHERE NL.NNFIRMA_ID = N.ID)) AND M.STATUS = 'P'
  ) AS SALDAKONTI_PROFORMA_DEM,
  
  -- Saldo, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_SIT,
  
  -- Saldo, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
  ) AS SALDAKONTI_DEM,
  
  -- Saldo odprti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_SIT,
  
   -- Saldo odprti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM_VALUTACIJE) < TRUNC(SYSDATE))
  ) AS SALDAKONTI_OUTSTANDING_DEM,
  
   -- Saldo prejeti, domaca valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    
  ) AS SALDAKONTI_RECEIVED_SIT,
  
   -- Saldo prejeti, tuja valuta
  (
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'R' AND S.ZAPRTO = '0')
    -
    (SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
    AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'P' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0')
    
  ) AS SALDAKONTI_RECEIVED_DEM,
  
  -- Depoziti, domaca valuta
  (
    SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
      AND S.VALUTA_RN = (SELECT DOMACAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM) <= TRUNC(SYSDATE)
      AND S.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
  ) DEPOSIT_SIT,
  
   -- Depoziti, tuja valuta
  (
    SELECT COALESCE(SUM(S.ZA_PLACILO - S.PORABLJENO), 0) FROM SALDKONT S WHERE S.ID_KUPCA = K.ID AND (N.ID IS NULL OR N.ID = S.NNFIRMA_ID)
      AND S.VALUTA_RN = (SELECT TUJAVALUTA FROM PARAM) AND UPPER(S.SDK_RN_TIP) = 'I' AND UPPER(S.SDK_RN_PL) = 'P' AND S.ZAPRTO = '0' AND TRUNC(S.DATUM) <= TRUNC(SYSDATE)
      AND S.VRSTA_RACUNA IN (SELECT K.SALDKONT FROM NKNJIZBA K WHERE K.DEPOSIT = 'Y')
  ) DEPOSIT_DEM

FROM KUPCI K, V_NNFIRMA_ID_OR_NULL N
);



CREATE OR REPLACE VIEW V_KUPCI_BALANCE AS (
  SELECT VKS.V_KUPCI_SALDAKONTI_ID AS V_KUPCI_BALANCE_ID, VKS.KUPCI_ID, VKS.NNFIRMA_ID, VKS.KUPCI_IME, VKS.KUPCI_PRIIMEK, VKS.SALDAKONTI_SIT, VKS.SALDAKONTI_DEM,
  -- Balance
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_DEM, 0) END AS BALANCE,
  
  -- Commercial balance
  CASE 
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'PartialProformaInvoices') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_PART_PROFORMA_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_PART_PROFORMA_DEM, 0) END)
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'UpostevanjePredracunovVSaldu') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_PROFORMA_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_PROFORMA_DEM, 0) END)
    ELSE 
      0
    END AS COMMERCIAL_BALANCE,
    
  -- Received balance
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_RECEIVED_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_RECEIVED_DEM, 0) END AS RECEIVED_BALANCE,
  
  -- Outstanding balance
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_OUTSTANDING_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_OUTSTANDING_DEM, 0) END AS OUTSTANDING_BALANCE,
  
  -- Deposits
  CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.DEPOSIT_SIT, 0) ELSE COALESCE(VKS.DEPOSIT_DEM, 0) END AS DEPOSIT,
  
  -- Total balance (balance + commercial balance)
  (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_DEM, 0) END) +
  (CASE 
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'PartialProformaInvoices') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_PART_PROFORMA_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_PART_PROFORMA_DEM, 0) END)
    WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'UpostevanjePredracunovVSaldu') = '1' THEN
      (CASE WHEN VKS.KUPCI_DOMACA_VALUTA = 'Y' THEN COALESCE(VKS.SALDAKONTI_PROFORMA_SIT, 0) ELSE COALESCE(VKS.SALDAKONTI_PROFORMA_DEM, 0) END)
    ELSE 
      0
    END) AS TOTAL_BALANCE
  FROM V_KUPCI_SALDAKONTI VKS
);


CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.INTERNI_OPIS AS VRSTA_DESC,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC,
    -- Owner contract data
  (SELECT OBJEKT FROM M_POGODBE M WHERE M.ID_LASTNIKA = K.ID AND M.ID_PLOVILA IS NULL AND ROWNUM = 1 AND M.DATUM_ZACETKA = (SELECT MAX(M2.DATUM_ZACETKA) FROM M_POGODBE M2 WHERE M2.ID_LASTNIKA = K.ID AND M2.ID_PLOVILA IS NULL) ) AS POGODBA_OBJEKT,
  (SELECT N_PRIVEZA FROM M_POGODBE M WHERE M.ID_LASTNIKA = K.ID AND M.ID_PLOVILA IS NULL AND ROWNUM = 1 AND M.DATUM_ZACETKA = (SELECT MAX(M2.DATUM_ZACETKA) FROM M_POGODBE M2 WHERE M2.ID_LASTNIKA = K.ID AND M2.ID_PLOVILA IS NULL) ) AS POGODBA_PRIVEZ
   
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
);

CREATE OR REPLACE VIEW V_KUPCI_PLOVILA AS (
  SELECT CONCAT(CONCAT(K.ID, '-'), P.ID) AS KUPCI_PLOVILA_ID, K.ID AS ID_LASTNIKA, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.NASLOV AS KUPCI_NASLOV, K.MESTO AS KUPCI_MESTO, K.POSTA AS KUPCI_POSTA, K.VRSTA AS KUPCI_VRSTA,
  K.NDRZAVA AS KUPCI_NDRZAVA, K.EMAIL AS KUPCI_EMAIL, K.TELEFON_1 AS KUPCI_TELEFON_1, K.YACHT_CLUB_ID, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.ACT AS KUPCI_ACT, K.TELEX AS KUPCI_TELEX, K.GSM AS KUPCI_GSM, K.TELEFON_2 AS KUPCI_TELEFON_2, 
  K.DAVCNA_STEVILKA AS KUPCI_DAVCNA_STEVILKA, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, K.SALDAKONTI_SIT AS KUPCI_SALDAKONTI_SIT, K.SALDAKONTI_DEM AS KUPCI_SALDAKONTI_DEM, K.SALDAKONTI_KOM AS KUPCI_SALDAKONTI_KOM, K.INT_CODE AS KUPCI_INT_CODE,
  K.VEHICLE_REGISTRATION_NUM AS KUPCI_VEHICLE_REGISTRATION_NUM,
  P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME, P.REGISTRSKA_N AS PLOVILA_REGISTRSKA_N, P.MODEL AS PLOVILA_MODEL, P.NTIP AS PLOVILA_NTIP, P.NZASTAVA AS PLOVILA_NZASTAVA, P.TRENUTNI_OBJEKT_PRIVEZA, P.TRENUTNA_N_PRIVEZA, P.TRENUTNO_DO, 
  P.POGODBENI_OBJEKT_PRIVEZA, P.POGODBENA_N_PRIVEZA, P.POGODBA_DO, P.DOLZINA AS PLOVILA_DOLZINA, P.SIRINA AS PLOVILA_SIRINA, P.GREZ AS PLOVILA_GREZ, P.BOOKING AS PLOVILA_BOOKING, P.ACT AS PLOVILA_ACT, VPT.ID_PRIVEZ AS ID_PRIVEZ_TEMP, 
  VPT.NNLOCATION_ID AS ID_LOCATION_TEMP, VPC.ID_PRIVEZ AS ID_PRIVEZ_CONTRACT, VPC.NNLOCATION_ID AS ID_LOCATION_CONTRACT, VK.POGODBA_OBJEKT AS KUPCI_POGODBA_OBJEKT, VK.POGODBA_PRIVEZ AS KUPCI_POGODBA_PRIVEZ
  FROM KUPCI K
  LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA = K.ID
  LEFT OUTER JOIN V_KUPCI VK ON VK.ID = K.ID
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPT ON VPT.OBJEKT = P.TRENUTNI_OBJEKT_PRIVEZA AND VPT.N_PRIVEZA = P.TRENUTNA_N_PRIVEZA
  LEFT OUTER JOIN V_PRIVEZ_LOCATION VPC ON VPC.OBJEKT = P.POGODBENI_OBJEKT_PRIVEZA AND VPC.N_PRIVEZA = P.POGODBENA_N_PRIVEZA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1089, SYSDATE, '5.5', 1009, 'Owner balance')
;
