ALTER TABLE NCARD
ADD NNLOCATION_ID NUMBER;

CREATE OR REPLACE VIEW V_NCARD AS (
SELECT N.NCARD, N.ID_LASTNIKA, N.ID_PLOVILA, N.VELJA_OD, N.VELJA_DO, N.SERIALNUMBER, N.NCARD_TYPE, N."COMMENT", N.STATUS, N.NNLOCATION_ID,
NCT.OPIS AS NCARD_TYPE_OPIS, NCT.INTERNI_OPIS AS NCARD_TYPE_INTERNI_OPIS, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, P.IME AS PLOVILA_IME
FROM NCARD N
LEFT OUTER JOIN NCARD_TYPE NCT ON NCT.ID = N.NCARD_TYPE
LEFT OUTER JOIN KUPCI K ON K.ID = N.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = N.ID_PLOVILA
);

ALTER TABLE S_ZAKLJUCEK 
ADD ID NUMBER;

CREATE SEQUENCE S_ZAKLJUCEK_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

UPDATE S_ZAKLJUCEK 
SET ID = S_ZAKLJUCEK_SEQ.NEXTVAL
WHERE ID IS NULL;

CREATE OR REPLACE
TRIGGER S_ZAKLJUCEK_TRG
BEFORE INSERT
ON S_ZAKLJUCEK
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
	IF (:NEW.ID IS NULL) THEN
          SELECT S_ZAKLJUCEK_SEQ.NEXTVAL INTO :NEW.ID FROM DUAL;;
	END IF;;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1335, SYSDATE, '5.5', 1255, 'Ncard lokacija')
;