DROP VIEW V_NNPRIVEZ;

CREATE OR REPLACE VIEW V_NNPRIVEZ AS (
SELECT N.ID_PRIVEZ, N.OBJEKT, N.N_PRIVEZA, N.KATEGORIJA, N.DOLZINA, N.GLOBINA, N.SIRINA, N.VISINA, N.LIMIT, N.ZASEDENO, N.SORT, N.SORT_PRIKAZ, N.DOCKWALK, N.SUBLEASE,
NPO.NAZIV AS NNPOMOL_NAZIV, NPO.INTERNI_OPIS AS NNPOMOL_INTERNI_OPIS, NPO.NNPOMOL_TYPE AS NNPOMOL_TYPE, NPO.NNLOCATION_ID, NOB.BERTH_NAME_BUILD_INSTRUCTION,
-- Last note
(SELECT PB.BELEZKA FROM PRIVEZIBELEZKE PB WHERE PB.ID_PRBELEZKE = (SELECT MAX(PB2.ID_PRBELEZKE) 
FROM PRIVEZIBELEZKE PB2 WHERE PB2.ID_PRIVEZ = N.ID_PRIVEZ AND PB.VELJAVNA = 'Y' AND COALESCE(PB.HIDDEN, 'N') <> 'Y')) AS LAST_NOTE,
-- Last 10 notes
(SELECT RTRIM(XMLAGG(XMLELEMENT(e, CASE WHEN SEQNUM <= 10 THEN BELEZKA END, ', ').EXTRACT('//text()') ORDER BY DATUMKREIRANJA DESC).getclobval(),', ') NOTES
FROM (SELECT PB.*, ROW_NUMBER() OVER (PARTITION BY ID_PRIVEZ ORDER BY DATUMKREIRANJA DESC) AS SEQNUM FROM PRIVEZIBELEZKE PB) PB
WHERE PB.ID_PRIVEZ = N.ID_PRIVEZ AND PB.VELJAVNA = 'Y' AND COALESCE(PB.HIDDEN, 'N') <> 'Y'
) AS NOTES
FROM NNPRIVEZ N
LEFT OUTER JOIN NNPOMOL NPO ON NPO.SIFRA = N.KATEGORIJA 
LEFT OUTER JOIN NNOBJEKT NOB ON NOB.SIFRA = N.OBJEKT
);

DROP VIEW V_WEB_PAGE_TEMPLATE;

CREATE OR REPLACE VIEW V_WEB_PAGE_TEMPLATE AS (
  SELECT WPT.ID_WEB_PAGE_TEMPLATE, WPT.NAME, WPT.CONTENT, WPT.ACTIVE, WPT.NNLOCATION_ID, WPT.TYPE, WPT.MAIN_VALUE,
  WTT.OPIS AS TYPE_OPIS, WTT.INTERNI_OPIS AS TYPE_INTERNI_OPIS
  FROM WEB_PAGE_TEMPLATE WPT
  LEFT OUTER JOIN NNWEB_PAGE_TEMPLATE_TYPE WTT ON WTT.SIFRA = WPT.TYPE
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1539, SYSDATE, '5.5', 1459, 'VNnprivez')
;
